package com.fp.persistence.parmas.fun;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import javax.persistence.Version;

import java.lang.reflect.Field;

import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMDETALLEIMPORTACION*/
@Entity(name="TarmDetalleImportacion")
@Table(name="TARMDETALLEIMPORTACION")
public class TarmDetalleImportacion extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmDetalleImportacion
*/
@Id
@Column(name="CDETALLEIMPORTACION" ,nullable=false, updatable=false)
private Long pk;
@Column(name="CIMPORTACION", nullable=true)

/**
* null
*/
private Long cimportacion;

@Column(name="CSOLICITUD", nullable=true)

/**
* Codigo de solicitud de controld e armas
*/
private String csolicitud;

@Column(name="CARMA", nullable=true)

/**
* null
*/
private String carma;

@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* null
*/
private Integer recordversion;

/**Contructor por defecto*/
public TarmDetalleImportacion(){
}
/**Contructor de TarmDetalleImportacion
@param pPk Clave Primaria del entity
*/
public TarmDetalleImportacion(Long pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmDetalleImportacion
*/
public static TarmDetalleImportacion find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmDetalleImportacion obj = pEntityManager.find(TarmDetalleImportacion.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmDetalleImportacion
@return El objeto que referencia a la Clave primaria de TarmDetalleImportacion
*/
public Long getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmDetalleImportacion
@param pPk El objeto que referencia a la nueva Clave primaria de TarmDetalleImportacion
*/
public void setPk(Long pPk){
  pk=pPk;
}
/**Obtiene el valor de cimportacion
@return valor de cimportacion*/
public Long getCimportacion(){
  return cimportacion;
}
/**Fija el valor de cimportacion
@param pCimportacion nuevo Valor de cimportacion*/
public void setCimportacion(Long pCimportacion){
  cimportacion=pCimportacion;
}

/**Obtiene el valor de csolicitud
@return valor de csolicitud*/
public String getCsolicitud(){
  return csolicitud;
}
/**Fija el valor de csolicitud
@param pCsolicitud nuevo Valor de csolicitud*/
public void setCsolicitud(String pCsolicitud){
  csolicitud=pCsolicitud;
}

/**Obtiene el valor de carma
@return valor de carma*/
public String getCarma(){
  return carma;
}
/**Fija el valor de carma
@param pCarma nuevo Valor de carma*/
public void setCarma(String pCarma){
  carma=pCarma;
}

/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmDetalleImportacion))return false;
    TarmDetalleImportacion that = (TarmDetalleImportacion) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmDetalleImportacion
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmDetalleImportacion
*/
public Object createInstance(){
 TarmDetalleImportacion instance=new TarmDetalleImportacion();	
 return instance;
}
/**Clona la entidad TarmDetalleImportacion
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmDetalleImportacion p=(TarmDetalleImportacion)this.clone();
  return p;
}
}
